## Backtrace-Overview

- Backtrace service to support the overview feature by serving and caching CRDB queries

## Development
- `yarn watch-build` in one terminal
- `NODE_ENV=development yarn watch-start` in a second terminal
- Alternatively: `NODE_ENV=development yarn watch-debug` in the second terminal to enable debugging via chrome devtools

## Schema migrations
Run all migrations which haven't been run yet:
- `NODE_ENV=development yarn exec -- knex migrate:latest`
Create a new migration:
- `NODE_ENV=development yarn exec -- knex migrate:make add_position_to_repositories`
Roll back one migration:
- `NODE_ENV=development yarn exec -- knex migrate:down`
More commands:
- `NODE_ENV=development yarn exec -- knex --help`
On a production server:
- `user@overview01:/opt/backtrace/services/backtrace-overview-code$ sudo NODE_ENV=production npm run-script exec -- ./node_modules/.bin/knex migrate:latest`

## Tasks
Task files can be used to migrate data, after doing a schema migration.
For example, after adding a "position" column to the queries table, we might want to set it to a proper value for every row in the queries table.
An example of this kind of task is in `tasks/add_position_to_queries.js`
To run it, your current working directory _must_ be the project root. It will not work otherwise.
Then run:
- `NODE_ENV=development node ./tasks/add_position_to_queries.js`
On a production server:
- `user@overview01:/opt/backtrace/services/backtrace-overview-code$ sudo NODE_ENV=production npm run-script exec -- node ./tasks/copy_queries.js`
