"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addAggregation = exports.removeAggregation = exports.getEmptyQuery = void 0;
const attributeAggregations_1 = require("./attributeAggregations");
function getEmptyQuery() {
    return {
        filter: undefined,
        fold: undefined,
        order: undefined,
        group: undefined,
        offset: undefined,
        limit: undefined,
        select: undefined,
        table: undefined,
    };
}
exports.getEmptyQuery = getEmptyQuery;
function removeAggregation(query, attribute, aggOp) {
    if (query.fold && query.fold[attribute]) {
        const index = query.fold[attribute].findIndex(function (agg) {
            return attributeAggregations_1.getAggregationOp(agg) === aggOp;
        });
        if (index > -1) {
            query.fold[attribute].splice(index, 1);
        }
    }
}
exports.removeAggregation = removeAggregation;
function addAggregation(query, attribute, aggregation) {
    if (query.fold && query.fold[attribute]) {
        query.fold[attribute].push(aggregation);
    }
    else if (query.fold) {
        query.fold[attribute] = [aggregation];
    }
    else {
        query.fold = {
            [attribute]: [aggregation],
        };
    }
}
exports.addAggregation = addAggregation;
//# sourceMappingURL=index.js.map